/* x-y-z coordinates */
typedef struct data_strct {
   double x;
   double y;
   double z;
} data;

/* triangles */
typedef struct tria_strct {
   data pt1;
   data pt2;
   data pt3;
   struct tria_strct *next;
   struct tria_strct *prev;
} tria;

typedef struct tria_strct *triaptr;
triaptr tria_listhead;
triaptr tria_listtail;

/* segments */
typedef struct segm_strct {
   data pt1;
   data pt2;
   struct segm_strct *next;
   struct segm_strct *prev;
} segm;

typedef struct segm_strct *segmptr;
segmptr segm_listhead;
segmptr segm_listtail;

/* nodes */
typedef struct node_strct {
   data pt;
   struct node_strct *next;
   struct node_strct *prev;
} node;

typedef struct node_strct *nodeptr;

/* plots */
typedef struct plot_strct {
   double level;
   struct node_strct *nodehead;
   struct node_strct *nodetail;
   struct plot_strct *next;
   struct plot_strct *prev;
} plot;

typedef struct plot_strct *plotptr;
plotptr plot_listhead;
plotptr plot_listtail;

/* boundaries */
double xmin, ymin, xmax, ymax, zmin, zmax;

/* output data of single contour */
int    cont_out;
double cont_level;

/* expand the data into a surface mesh, SAMPLE-style output */
int    expand;

/* use the old SPLAT contour format */
int    oldformat;

/* input image file */
char   *imagefile;
